using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Reflection;

namespace TestApplication
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void buttonMethod1_Click(object sender, EventArgs e)
		{
			statusLabel1.Text = string.Empty;
			object addinInstance = GetAddinObject();
			if (addinInstance != null)
				try
				{
					object value = addinInstance.GetType().InvokeMember("Method1", BindingFlags.InvokeMethod, null, addinInstance, new object[] { });
					MessageBox.Show(value.ToString());
				}
				finally { Marshal.ReleaseComObject(addinInstance); }
		}

		private void buttonMethod2_Click(object sender, EventArgs e)
		{
			statusLabel1.Text = string.Empty;
			object addinInstance = GetAddinObject();
			if (addinInstance != null)
				try
				{
					object value = addinInstance.GetType().InvokeMember("Method2", BindingFlags.InvokeMethod, null, addinInstance, new object[] { });
					MessageBox.Show(value.ToString());
				}
				finally { Marshal.ReleaseComObject(addinInstance); }
		}

		private void buttonMethod3_Click(object sender, EventArgs e)
		{
			statusLabel1.Text = string.Empty;
			object addinInstance = GetAddinObject();
			if (addinInstance != null)
				try
				{
					object value = addinInstance.GetType().InvokeMember("Method3", BindingFlags.InvokeMethod, null, addinInstance, new object[] { });
					MessageBox.Show(value.ToString());
				}
				finally { Marshal.ReleaseComObject(addinInstance); }
		}

		private void buttonGetPropery_Click(object sender, EventArgs e)
		{
			statusLabel1.Text = string.Empty;
			object addinInstance = GetAddinObject();
			if (addinInstance != null)
				try
				{
					object value = addinInstance.GetType().InvokeMember("Prop", BindingFlags.GetProperty, null, addinInstance, new object[] { });
					MessageBox.Show(value.ToString());
				}
				finally { Marshal.ReleaseComObject(addinInstance); }
		}

		private void buttonSetProperty_Click(object sender, EventArgs e)
		{
			statusLabel1.Text = string.Empty;
			object addinInstance = GetAddinObject();
			if (addinInstance != null)
				try
				{
					object value = FormEnterValue.InputBox();
					addinInstance.GetType().InvokeMember("SetProperty", BindingFlags.InvokeMethod, null, addinInstance, new object[] { value });
				}
				finally { Marshal.ReleaseComObject(addinInstance); }
		}

		private object GetAddinObject()
		{
			Excel._Application app = null;
			try
			{
				app = Marshal.GetActiveObject("Excel.Application") as Excel._Application;
			}
			catch
			{
				statusLabel1.Text = "Excel is not running.";
			}
			if (app != null)
				try
				{
					Office.COMAddIns addins = app.COMAddIns;
					if (addins != null)
						try
						{
							// ProgID of our add-in
							object index = "ExcelAddin_CS.AddinModule";
							Office.COMAddIn addin = null;
							try
							{
								addin = addins.Item(ref index);
							}
							catch
							{
								statusLabel1.Text = "COM add-in is not registered.";
							}
							if (addin != null)
								try
								{
									if (addin.Connect)
									{
										return addin.Object;
									}
									else
										statusLabel1.Text = "COM add-in is not enabled.";
								}
								finally { Marshal.ReleaseComObject(addin); }
						}
						finally { Marshal.ReleaseComObject(addins); }
				}
				finally { Marshal.ReleaseComObject(app); }
			return null;
		}
	}
}